<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly.
}

// Process a vote

add_action('wp_ajax_bbpress_post_vote_link_clicked','bbpress_post_add_vote');
add_action('wp_ajax_nopriv_bbpress_post_vote_link_clicked','bbpress_post_add_vote');

function bbpress_post_add_vote(){
    $post_id = (int) $_POST['post_id'];
    $topic_id = bbp_get_reply_topic_id($post_id);
    $topic_status = get_post_status( $topic_id );
	if($topic_status == 'closed' && apply_filters('bbp_voting_disable_voting_on_closed_topic', false)) die('0');
    $direction = (int) $_POST['direction'];
    $direction = in_array($direction, [1, -1]) ? $direction : 0; // Enforce 1 or -1
    // $voting_cookie = unserialize($_COOKIE['bbp_voting']);
    $voting_log = get_post_meta($post_id, 'bbp_voting_log', true);
    $voting_log = is_array($voting_log) ? $voting_log : array(); // Set up new array
    $client_ip = $_SERVER['REMOTE_ADDR'];
    $identifier = is_user_logged_in() ? get_current_user_id() : $client_ip;
    $admin_bypass = current_user_can('administrator') && apply_filters('bbp_voting_admin_bypass', false);
    $reverse_vote = false;
    // Admin bypass skips the restriction checks
    if(!$admin_bypass) {
        // Catch user voted already (by cookie)
        // if(isset($voting_cookie[$post_id])) {
        //     echo 'Not allowed to vote twice';
        //     exit;
        // } else {
            // Catch user voted already (by user ID or IP)
            if(array_key_exists($identifier, $voting_log)) {
                // Identifier found
                if($voting_log[$identifier] === $direction) {
                    // Voting again in the same direction
                    echo '0';
                    exit;
                } else {
                    // Changing the vote in different direction
                    $reverse_vote = true;
                }
            } 
        // }
    }
    // All good, add the user's vote
    $score = (int) get_post_meta($post_id, 'bbp_voting_score', true);
    if($direction > 0) {
        $ups = (int) get_post_meta($post_id, 'bbp_voting_ups', true);
        update_post_meta($post_id, 'bbp_voting_ups', $ups + 1);
        $score = $score + 1;
        if($reverse_vote) {
            $downs = (int) get_post_meta($post_id, 'bbp_voting_downs', true);
            update_post_meta($post_id, 'bbp_voting_downs', $downs + 1);
            $score = $score + 1;
        }
    } elseif($direction < 0) {
        $downs = (int) get_post_meta($post_id, 'bbp_voting_downs', true);
        update_post_meta($post_id, 'bbp_voting_downs', $downs - 1);
        $score = $score - 1;
        if($reverse_vote) {
            $ups = (int) get_post_meta($post_id, 'bbp_voting_ups', true);
            update_post_meta($post_id, 'bbp_voting_ups', $ups - 1);
            $score = $score - 1;
        }
    }
    // Update the score
    update_post_meta($post_id, 'bbp_voting_score', $score);
    // Log the user's ID or IP
    $voting_log[$identifier] = $direction;
    update_post_meta($post_id, 'bbp_voting_log', $voting_log);
    // Set the cookie
    // $voting_cookie[$post_id] = true;
    // setcookie('bbp_voting', serialize($voting_cookie), time() + (86400 * 30 * 365), '/');
    do_action('bbp_voting_voted', $post_id, $direction, $score);
    echo $score;
    exit;
}