<?php
/*
Plugin Name: bbPress Voting
Plugin URI: http://wordpress.org/extend/plugins/bbp-voting/
Author: natekinkead
Author URI: https://wpforthewin.com
Description: Vote bbPress topics and replies up or down to surface the best replies
Version: 1.3.5
Requires at least: 3.0.0
Tested up to: 5.4.2
License: GPLv3
*/

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly.
}

$bbp_voting_hooks = array(
    'bbp_voting_show_labels' => 'bool',
    'bbp_voting_helpful' => 'string',
    'bbp_voting_not_helpful' => 'string',
    'bbp_voting_only_topics' => 'bool',
    'bbp_voting_only_replies' => 'bool',
    'bbp_voting_disable_voting_on_closed_topic' => 'bool',
    'bbp_voting_admin_bypass' => 'bool',
    'sort_bbpress_topics_by_votes' => 'bool',
    'sort_bbpress_replies_by_votes' => 'bool',
);

foreach($bbp_voting_hooks as $bbp_voting_hook => $bbp_voting_hook_type) {
    add_filter( $bbp_voting_hook, 'bbp_voting_hook_setting');
}

function bbp_voting_hook_setting($value) {
    global $bbp_voting_hooks;
    $setting = current_filter();
    $type = $bbp_voting_hooks[$setting];
    $setting_value = get_option( $setting );
    if($type == 'bool') {
        return $setting_value === 'true'? true : false;
    } else {
        if(!empty($setting_value)) return $setting_value;
        return $value;
    }
}

if(is_admin()) {
    require_once('backend.php');
} else {
    require_once('frontend.php');
}
require_once('ajax.php');

// Hook Usage Examples

// Filters:

// add_filter( 'bbp_voting_show_labels', '__return_false' );
// add_filter( 'bbp_voting_helpful', function() { return "Good" } );
// add_filter( 'bbp_voting_not_helpful', function() { return "Bad" } );
// add_filter( 'bbp_voting_only_topics', '__return_true' );
// add_filter( 'bbp_voting_admin_bypass', '__return_true' );
// add_filter( 'sort_bbpress_replies_by_votes', '__return_true' );
// add_filter( 'bbp_voting_allowed_on_forum', 'allowed_voting_forums', 10, 2 );
// function allowed_voting_forums( $allowed, $forum_id ) {
//     if( in_array( $forum_id, array(123, 124, 125) ) ) {
//         $allowed = true;
//     } else {
//         $allowed = false;
//     }
//     return $allowed;
// }

// Actions:

// add_action( 'bbp_voting_voted', 'my_function_on_bbp_vote', 10, 3 );
// function my_function_on_bbp_vote( $post_id, $direction, $score ) {
//     // Do something
//     // $post_id will be the ID of the topic or reply that was voted on
//     // $direction will be 1 or -1 representing the upvote or downvote
//     // $score will be the new total score
// }

